#line 1 "C:/DOCS/DYNAMIC GAMING/DG stuff/Embedded Systems/Test Projects/encoder test 6/encoder test 6.c"

unsigned char ReadBuffer[1] absolute 0x500;
unsigned char WriteBuffer[7] absolute 0x540;
unsigned short int buttons;
unsigned long int temp1,temp2,temp3;
signed int count1,count2,count3;
unsigned char sensorA1,sensorA2,oldsensorA1,oldsensorA2;
signed int directionA;
unsigned char flag2,flag3;
unsigned int QUAD2A, QUAD2A_OLD, QUAD2A_NEW, QUAD2B, QUAD2B_OLD, QUAD2B_NEW;
unsigned int QUAD3A, QUAD3A_OLD, QUAD3A_NEW, QUAD3B, QUAD3B_OLD, QUAD3B_NEW;

void interrupt(void){

 if(INTCON.INT0IF==1)
 {
 directionA = 0;
 sensorA1 = PORTB.RB0;
 sensorA2 = PORTB.RB1;
 if (!((oldsensorA1 ^ sensorA1) & !(oldsensorA2 ^ sensorA2)) )
 {
 directionA = -1;
 if (oldsensorA1 ^ sensorA2) directionA = 1;
 }

 count1 += directionA;
 oldsensorA1 = sensorA1;
 oldsensorA2 = sensorA2;

 INTCON.INT0IF = 0;

 }
 else

 if(INTCON.RBIF==1)
 {
 QUAD2A = PORTB.RB4;
 QUAD2B = PORTB.RB5;

 QUAD2A_NEW = QUAD2A;
 QUAD2B_NEW = QUAD2B;

 if (QUAD2A_NEW + QUAD2B_NEW == 2) flag2 = 1;

 if ((flag2 == 1) & (QUAD2A_NEW + QUAD2B_NEW == 1))
 {
 QUAD2A_OLD = QUAD2A_NEW;
 QUAD2B_OLD = QUAD2B_NEW;
 flag2 = 2;
 }
 if ((flag2 == 2) & (QUAD2A_NEW + QUAD2B_NEW == 0))
 {
 if (QUAD2B_OLD == 1) {count2++; flag2 = 3;}
 if (QUAD2A_OLD == 1) {count2--; flag2 = 3;}
 }


 QUAD3A = PORTB.RB6;
 QUAD3B = PORTB.RB7;

 QUAD3A_NEW = QUAD3A;
 QUAD3B_NEW = QUAD3B;

 if (QUAD3A_NEW + QUAD3B_NEW == 2) flag3 = 1;

 if ((flag3 == 1) & (QUAD3A_NEW + QUAD3B_NEW == 1))
 {
 QUAD3A_OLD = QUAD3A_NEW;
 QUAD3B_OLD = QUAD3B_NEW;
 flag3 = 2;
 }
 if ((flag3 == 2) & (QUAD3A_NEW + QUAD3B_NEW == 0))
 {
 if (QUAD3B_OLD == 1) {count3++; flag3 = 3;}
 if (QUAD3A_OLD == 1) {count3--; flag3 = 3;}
 }


 INTCON.RBIF=0;
 }
else

USB_Interrupt_Proc();



}

void main() {

 PORTB = 0x00;
 TRISB = 0xFF;
 PORTC = 0x00;
 TRISC = 0xC4;

 count1 = 0x0000;
 count2 = 0x0000;
 count3 = 0x0000;

 INTCON.GIE = 1;
 INTCON.INT0IF = 0;
 INTCON.INTEDG0 = 1;
 INTCON.INT0IE = 1;
 INTCON.RBIF = 0;
 INTCON.RBIE = 1;



 HID_Enable(&ReadBuffer, &WriteBuffer);

 delay_ms(1000);


do {

 if (count1 > 1023) count1 = 1023;
 else
 if (count1 < 0) count1 = 0;
 temp1 = count1 - 511;
 WriteBuffer[0] = temp1 & 0x00FF;
 WriteBuffer[1] = (temp1 & 0xFF00) >>8;

 if (count2 > 1023) count2 = 1023;
 else
 if (count2 < 0) count2 = 0;
 temp2 = count2 - 511;
 WriteBuffer[2] = temp2 & 0x00FF;
 WriteBuffer[3] = (temp2 & 0xFF00) >>8;

 if (count3 > 1023) count3 = 1023;
 else
 if (count3 < 0) count3 = 0;
 temp3 = count3 - 511;
 WriteBuffer[4] = temp3 & 0x00FF;
 WriteBuffer[5] = (temp3 & 0xFF00) >>8;

 buttons = PORTC & 0x07;
 WriteBuffer[6] = (buttons & 0x07);



 while(!HID_Write(&WriteBuffer, 7));


 }while(1);
 }
